/* $Id: mac_db.h 194 2007-04-28 13:28:52Z pkun $ */
#ifndef _PARSEC_MAC_DB_WC_H_
#define _PARSEC_MAC_DB_WC_H_

#include <pwd.h>
#include <parsec/mac_db.h>
#include <wchar.h>

struct wcmac_user {
	wchar_t *name;
	struct mac_label min;
	struct mac_label max;
};

struct wcmac_lev {
	wchar_t *name;
	mac_lev_t value;
};

struct wcmac_cat {
	wchar_t *name;
	mac_cat_t value;
};

#ifdef __cplusplus
extern "C" {
#endif

/* mac */
extern int wcsetmacent(mac_han_t han);
extern int wcendmacent(mac_han_t han);

extern struct wcmac_user *wcgetmacent(mac_han_t han);
extern struct wcmac_user *wcfgetmacent(FILE *fd);

extern struct wcmac_user *wcgetmacnam(mac_han_t han, const wchar_t *name);
extern struct wcmac_user *wcgetmacuid(mac_han_t han, uid_t uid);
extern int wcrmmacnam(mac_han_t han, const wchar_t *name);
extern int wcfputmacent(FILE *fd, const struct wcmac_user *mu);
extern int wcputmacent(mac_han_t han, const struct wcmac_user *mu);

extern int wcfreemacent(struct wcmac_user *res);

/* level */
extern int wcsetlevent(lev_han_t han);
extern int wcendlevent(lev_han_t han);

extern struct wcmac_lev *wcgetlevent(lev_han_t han);
extern struct wcmac_lev *wcfgetlevent(FILE *fd);

extern struct wcmac_lev *wcgetlevnam(lev_han_t han, const wchar_t *name);
extern int wcrmlevnam(lev_han_t han, const wchar_t *name);
extern int wcfputlevent(FILE *fd, const struct wcmac_lev *mu);
extern int wcputlevent(lev_han_t han, const struct wcmac_lev *mu);

extern struct wcmac_lev *wcgetlevval(lev_han_t han, mac_lev_t value);
extern int wcrmlevval(lev_han_t han, mac_lev_t value);
extern int wcfreelevent(struct wcmac_lev *res);

/* cat */
extern int wcsetcatent(cat_han_t han);
extern int wcendcatent(cat_han_t han);

extern struct wcmac_cat *wcgetcatent(cat_han_t han);
extern struct wcmac_cat *wcfgetcatent(FILE *fd);

extern struct wcmac_cat *wcgetcatnam(cat_han_t han, const wchar_t *name);
extern int wcrmcatnam(cat_han_t han, const wchar_t *name);
extern int wcfputcatent(FILE *fd, const struct wcmac_cat *mu);
extern int wcputcatent(cat_han_t han, const struct wcmac_cat *mu);

extern struct wcmac_cat *wcgetcatval(cat_han_t han, mac_cat_t value);
extern int wcrmcatval(cat_han_t han, mac_cat_t value);
extern int wcfreecatent(struct wcmac_cat *res);

#ifdef __cplusplus
}
#endif

#endif	/* _PARSEC_MAC_DB_WC_H_ */
